"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simulateTransaction = exports.sendSignAndConfirmTransactions = exports.sendAndConfirmSignedTransaction = exports.awaitTransactionSignatureConfirmation = void 0;
var web3_js_1 = require("@solana/web3.js");
var bs58 = require("bs58");
var tools_1 = require("./tools");
var types_1 = require("./types");
var MAXIMUM_NUMBER_OF_BLOCKS_FOR_TRANSACTION = 152;
/**
 * waits for transaction confirmation
 * @param timeoutStrategy can be TimeStrategy: pure time based timeout or BlockHeightStrategy: blockheight pool strategy
 */
var awaitTransactionSignatureConfirmation = function (_a) {
    var txid = _a.txid, confirmLevel = _a.confirmLevel, connection = _a.connection, timeoutStrategy = _a.timeoutStrategy;
    return __awaiter(void 0, void 0, void 0, function () {
        var timeoutBlockHeight, timeout, startTimeoutCheck, done, confirmLevels, subscriptionId, result;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    timeoutBlockHeight = timeoutStrategy instanceof types_1.BlockHeightStrategy
                        ? timeoutStrategy.block.lastValidBlockHeight + MAXIMUM_NUMBER_OF_BLOCKS_FOR_TRANSACTION
                        : 0;
                    timeout = timeoutStrategy instanceof types_1.BlockHeightStrategy ? timeoutStrategy.startBlockCheckAfterSecs : timeoutStrategy.timeout;
                    startTimeoutCheck = false;
                    done = false;
                    confirmLevels = ['finalized'];
                    if (confirmLevel === 'confirmed') {
                        confirmLevels.push('confirmed');
                    }
                    else if (confirmLevel === 'processed') {
                        confirmLevels.push('confirmed');
                        confirmLevels.push('processed');
                    }
                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                            (function () { return __awaiter(void 0, void 0, void 0, function () {
                                var retrySleep;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            setTimeout(function () {
                                                if (done) {
                                                    return;
                                                }
                                                if (timeoutBlockHeight !== 0) {
                                                    startTimeoutCheck = true;
                                                }
                                                else {
                                                    done = true;
                                                    console.log('Timed out for txid: ', txid);
                                                    reject({ timeout: true });
                                                }
                                            }, timeout);
                                            try {
                                                subscriptionId = connection.onSignature(txid, function (result, context) {
                                                    subscriptionId = undefined;
                                                    done = true;
                                                    if (result.err) {
                                                        reject(result.err);
                                                    }
                                                    else {
                                                        resolve(result);
                                                    }
                                                }, 'processed');
                                            }
                                            catch (e) {
                                                done = true;
                                                console.log('WS error in setup', txid, e);
                                            }
                                            retrySleep = timeoutStrategy.getSignatureStatusesPoolIntervalMs;
                                            _a.label = 1;
                                        case 1:
                                            if (!!done) return [3 /*break*/, 3];
                                            // eslint-disable-next-line no-loop-func
                                            return [4 /*yield*/, (0, tools_1.sleep)(retrySleep)];
                                        case 2:
                                            // eslint-disable-next-line no-loop-func
                                            _a.sent();
                                            (function () { return __awaiter(void 0, void 0, void 0, function () {
                                                var promises, _a, signatureStatuses, currentBlockHeight, result_1, e_1;
                                                return __generator(this, function (_b) {
                                                    switch (_b.label) {
                                                        case 0:
                                                            _b.trys.push([0, 2, , 3]);
                                                            promises = [
                                                                connection.getSignatureStatuses([txid]),
                                                            ];
                                                            //if startTimeoutThreshold passed we start to check if
                                                            //current blocks are did not passed timeoutBlockHeight threshold
                                                            if (startTimeoutCheck) {
                                                                promises.push(connection.getBlockHeight('confirmed'));
                                                            }
                                                            return [4 /*yield*/, Promise.all(promises)];
                                                        case 1:
                                                            _a = _b.sent(), signatureStatuses = _a[0], currentBlockHeight = _a[1];
                                                            if (typeof currentBlockHeight !== undefined && timeoutBlockHeight <= currentBlockHeight) {
                                                                console.log('Timed out for txid: ', txid);
                                                                done = true;
                                                                reject({ timeout: true });
                                                            }
                                                            result_1 = signatureStatuses && signatureStatuses.value[0];
                                                            if (!done) {
                                                                if (!result_1)
                                                                    return [2 /*return*/];
                                                                if (result_1.err) {
                                                                    console.log('REST error for', txid, result_1);
                                                                    done = true;
                                                                    reject(result_1.err);
                                                                }
                                                                else if (!(result_1.confirmations || confirmLevels.includes(result_1.confirmationStatus))) {
                                                                    console.log('REST not confirmed', txid, result_1);
                                                                }
                                                                else {
                                                                    console.log('REST confirmed', txid, result_1);
                                                                    done = true;
                                                                    resolve(result_1);
                                                                }
                                                            }
                                                            return [3 /*break*/, 3];
                                                        case 2:
                                                            e_1 = _b.sent();
                                                            if (!done) {
                                                                console.log('REST connection error: txid', txid, e_1);
                                                            }
                                                            return [3 /*break*/, 3];
                                                        case 3: return [2 /*return*/];
                                                    }
                                                });
                                            }); })();
                                            return [3 /*break*/, 1];
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            }); })();
                        })];
                case 1:
                    result = _b.sent();
                    if (subscriptionId) {
                        connection.removeSignatureListener(subscriptionId).catch(function (e) {
                            console.log('WS error in cleanup', e);
                        });
                    }
                    done = true;
                    return [2 /*return*/, result];
            }
        });
    });
};
exports.awaitTransactionSignatureConfirmation = awaitTransactionSignatureConfirmation;
/**
 * send and waits for transaction to confirm
 * @param postSendTxCallback call back that will fire after sending tx before waiting for tx to be confirmed.
 */
var sendAndConfirmSignedTransaction = function (_a) {
    var signedTransaction = _a.signedTransaction, _b = _a.confirmLevel, confirmLevel = _b === void 0 ? 'processed' : _b, connection = _a.connection, postSendTxCallback = _a.postSendTxCallback, timeoutStrategy = _a.timeoutStrategy;
    return __awaiter(void 0, void 0, void 0, function () {
        var resendTimeout, rawTransaction, txid, startTime, done, err_1, simulateResult, e_2, i, line;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    resendTimeout = timeoutStrategy instanceof types_1.TimeStrategy ? timeoutStrategy.timeout : timeoutStrategy.startBlockCheckAfterSecs;
                    rawTransaction = signedTransaction.serialize();
                    txid = bs58.encode(signedTransaction.signatures[0].signature);
                    startTime = (0, tools_1.getUnixTs)();
                    return [4 /*yield*/, connection.sendRawTransaction(rawTransaction, {
                            skipPreflight: true,
                        })];
                case 1:
                    txid = _c.sent();
                    if (postSendTxCallback) {
                        try {
                            postSendTxCallback({ txid: txid });
                        }
                        catch (e) {
                            console.log("postSendTxCallback error ".concat(e));
                        }
                    }
                    done = false;
                    (function () { return __awaiter(void 0, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    if (!(!done && (0, tools_1.getUnixTs)() - startTime < resendTimeout)) return [3 /*break*/, 2];
                                    return [4 /*yield*/, (0, tools_1.sleep)(2000)];
                                case 1:
                                    _a.sent();
                                    connection.sendRawTransaction(rawTransaction, {
                                        skipPreflight: true,
                                    });
                                    return [3 /*break*/, 0];
                                case 2: return [2 /*return*/];
                            }
                        });
                    }); })();
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 4, 9, 10]);
                    return [4 /*yield*/, (0, exports.awaitTransactionSignatureConfirmation)({
                            txid: txid,
                            timeoutStrategy: timeoutStrategy,
                            confirmLevel: confirmLevel,
                            connection: connection,
                        })];
                case 3:
                    _c.sent();
                    return [3 /*break*/, 10];
                case 4:
                    err_1 = _c.sent();
                    if (err_1.timeout) {
                        throw { txid: txid };
                    }
                    simulateResult = null;
                    _c.label = 5;
                case 5:
                    _c.trys.push([5, 7, , 8]);
                    return [4 /*yield*/, simulateTransaction(connection, signedTransaction, 'single')];
                case 6:
                    simulateResult = (_c.sent()).value;
                    return [3 /*break*/, 8];
                case 7:
                    e_2 = _c.sent();
                    console.log('Simulate tx failed');
                    return [3 /*break*/, 8];
                case 8:
                    if (simulateResult && simulateResult.err) {
                        if (simulateResult.logs) {
                            for (i = simulateResult.logs.length - 1; i >= 0; --i) {
                                line = simulateResult.logs[i];
                                if (line.startsWith('Program log: ')) {
                                    throw {
                                        message: 'Transaction failed: ' + line.slice('Program log: '.length),
                                        txid: txid,
                                    };
                                }
                            }
                        }
                        throw {
                            message: JSON.stringify(simulateResult.err),
                            txid: txid,
                        };
                    }
                    throw { message: 'Transaction failed', txid: txid };
                case 9:
                    done = true;
                    return [7 /*endfinally*/];
                case 10: return [2 /*return*/, txid];
            }
        });
    });
};
exports.sendAndConfirmSignedTransaction = sendAndConfirmSignedTransaction;
/**
 * sign and send array of transactions in desired batches with different styles of send for each array
 */
var sendSignAndConfirmTransactions = function (_a) {
    var connection = _a.connection, wallet = _a.wallet, TransactionInstructions = _a.TransactionInstructions, timeoutStrategy = _a.timeoutStrategy;
    return __awaiter(void 0, void 0, void 0, function () {
        var maxTransactionsInBath, currentTransactions, unsignedTxns, transactionCallOrchestrator, _loop_1, i, signedTxns, _i, transactionCallOrchestrator_1, fcn, _b, _c, idx, transactionIdx, transactionInstructionIdx, e_3, forwardedTransactions, e_4;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    if (!wallet.publicKey)
                        throw new Error('Wallet not connected!');
                    maxTransactionsInBath = 40;
                    currentTransactions = TransactionInstructions.slice(0, maxTransactionsInBath);
                    unsignedTxns = [];
                    transactionCallOrchestrator = [];
                    _loop_1 = function (i) {
                        var _e, _f;
                        var transactionInstruction = currentTransactions[i];
                        var signers = [];
                        if (transactionInstruction.instructionsSet.length === 0) {
                            return "continue";
                        }
                        var transaction = new web3_js_1.Transaction({ feePayer: wallet.publicKey });
                        transactionInstruction.instructionsSet.forEach(function (instruction) {
                            transaction.add(instruction.transactionInstruction);
                            if (instruction.signers.length) {
                                signers.push.apply(signers, instruction.signers);
                            }
                        });
                        transaction.recentBlockhash = timeoutStrategy.block.blockhash;
                        if (signers.length) {
                            transaction.partialSign.apply(transaction, signers);
                        }
                        //we take last index of unsignedTransactions to have right indexes because
                        //if transactions was empty
                        //then unsigned transactions could not mach TransactionInstructions param indexes
                        var currentUnsignedTxIdx = unsignedTxns.length;
                        var currentTransactionCall = transactionCallOrchestrator[transactionCallOrchestrator.length - 1];
                        //we check if last item in current transactions call type is same
                        //if not then we create next transaction type
                        if (currentTransactionCall && currentTransactionCall.sequenceType === transactionInstruction.sequenceType) {
                            //we push reflection of transactionInstruction as object value for retry.
                            currentTransactionCall.transactionsIdx.push((_e = {},
                                _e[currentUnsignedTxIdx] = i,
                                _e));
                        }
                        else {
                            transactionCallOrchestrator.push({
                                //we push reflection of transactionInstruction as object value for retry.
                                transactionsIdx: [(_f = {}, _f[currentUnsignedTxIdx] = i, _f)],
                                sequenceType: transactionInstruction.sequenceType,
                            });
                        }
                        unsignedTxns.push(transaction);
                    };
                    for (i = 0; i < currentTransactions.length; i++) {
                        _loop_1(i);
                    }
                    console.log(transactionCallOrchestrator);
                    return [4 /*yield*/, wallet.signAllTransactions(unsignedTxns)];
                case 1:
                    signedTxns = _d.sent();
                    console.log('Transactions play type order', transactionCallOrchestrator.map(function (x) {
                        return __assign(__assign({}, x), { sequenceType: typeof x.sequenceType !== 'undefined' ? types_1.SequenceType[Number(x.sequenceType)] : 'Parallel' });
                    }));
                    console.log('Signed transactions', signedTxns);
                    _d.label = 2;
                case 2:
                    _d.trys.push([2, 15, , 16]);
                    _i = 0, transactionCallOrchestrator_1 = transactionCallOrchestrator;
                    _d.label = 3;
                case 3:
                    if (!(_i < transactionCallOrchestrator_1.length)) return [3 /*break*/, 12];
                    fcn = transactionCallOrchestrator_1[_i];
                    if (!(typeof fcn.sequenceType === 'undefined' || fcn.sequenceType === types_1.SequenceType.Parallel)) return [3 /*break*/, 5];
                    //wait for all Parallel
                    return [4 /*yield*/, Promise.all(fcn.transactionsIdx.map(function (idx) {
                            var transactionIdx = Number(Object.keys(idx)[0]);
                            var transactionInstructionIdx = idx[transactionIdx];
                            return function () { return __awaiter(void 0, void 0, void 0, function () {
                                var e_5;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            _a.trys.push([0, 2, , 3]);
                                            return [4 /*yield*/, (0, exports.sendAndConfirmSignedTransaction)({
                                                    connection: connection,
                                                    signedTransaction: signedTxns[transactionIdx],
                                                    timeoutStrategy: timeoutStrategy,
                                                })];
                                        case 1:
                                            _a.sent();
                                            return [3 /*break*/, 3];
                                        case 2:
                                            e_5 = _a.sent();
                                            if (typeof e_5 === 'object') {
                                                throw __assign(__assign({}, e_5), { transactionInstructionIdx: transactionInstructionIdx });
                                            }
                                            else {
                                                throw e_5;
                                            }
                                            return [3 /*break*/, 3];
                                        case 3: return [2 /*return*/];
                                    }
                                });
                            }); };
                        }))];
                case 4:
                    //wait for all Parallel
                    _d.sent();
                    _d.label = 5;
                case 5:
                    if (!(fcn.sequenceType === types_1.SequenceType.Sequential)) return [3 /*break*/, 11];
                    _b = 0, _c = fcn.transactionsIdx;
                    _d.label = 6;
                case 6:
                    if (!(_b < _c.length)) return [3 /*break*/, 11];
                    idx = _c[_b];
                    transactionIdx = Number(Object.keys(idx)[0]);
                    transactionInstructionIdx = idx[transactionIdx];
                    _d.label = 7;
                case 7:
                    _d.trys.push([7, 9, , 10]);
                    return [4 /*yield*/, (0, exports.sendAndConfirmSignedTransaction)({
                            connection: connection,
                            signedTransaction: signedTxns[transactionIdx],
                            timeoutStrategy: timeoutStrategy,
                        })];
                case 8:
                    _d.sent();
                    return [3 /*break*/, 10];
                case 9:
                    e_3 = _d.sent();
                    if (typeof e_3 === 'object') {
                        throw __assign(__assign({}, e_3), { transactionInstructionIdx: transactionInstructionIdx });
                    }
                    else {
                        throw e_3;
                    }
                    return [3 /*break*/, 10];
                case 10:
                    _b++;
                    return [3 /*break*/, 6];
                case 11:
                    _i++;
                    return [3 /*break*/, 3];
                case 12:
                    if (!(TransactionInstructions.length > maxTransactionsInBath)) return [3 /*break*/, 14];
                    forwardedTransactions = TransactionInstructions.slice(maxTransactionsInBath, TransactionInstructions.length);
                    return [4 /*yield*/, (0, exports.sendSignAndConfirmTransactions)({
                            connection: connection,
                            wallet: wallet,
                            TransactionInstructions: forwardedTransactions,
                            timeoutStrategy: timeoutStrategy,
                        })];
                case 13:
                    _d.sent();
                    _d.label = 14;
                case 14: return [3 /*break*/, 16];
                case 15:
                    e_4 = _d.sent();
                    console.log(e_4);
                    throw e_4;
                case 16: return [2 /*return*/];
            }
        });
    });
};
exports.sendSignAndConfirmTransactions = sendSignAndConfirmTransactions;
/** Copy of Connection.simulateTransaction that takes a commitment parameter. */
function simulateTransaction(connection, transaction, commitment) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, signData, wireTransaction, encodedTransaction, config, args, res;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    // @ts-ignore
                    _a = transaction;
                    return [4 /*yield*/, connection._recentBlockhash(
                        // @ts-ignore
                        connection._disableBlockhashCaching)];
                case 1:
                    // @ts-ignore
                    _a.recentBlockhash = _b.sent();
                    console.log('simulating transaction', transaction);
                    signData = transaction.serializeMessage();
                    wireTransaction = transaction._serialize(signData);
                    encodedTransaction = wireTransaction.toString('base64');
                    console.log('encoding');
                    config = { encoding: 'base64', commitment: commitment };
                    args = [encodedTransaction, config];
                    console.log('simulating data', args);
                    return [4 /*yield*/, connection._rpcRequest('simulateTransaction', args)];
                case 2:
                    res = _b.sent();
                    console.log('res simulating transaction', res);
                    if (res.error) {
                        throw new Error('failed to simulate transaction: ' + res.error.message);
                    }
                    return [2 /*return*/, res.result];
            }
        });
    });
}
exports.simulateTransaction = simulateTransaction;
